/* ====================================================================
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is SATC.
 *
 * The Initial Developer of the Original Code is Bogdan Mitu
 *
 * Copyright (C) 2001-2002 Bogdan Mitu
 *
 * ====================================================================
 */

header{ package satc.lang; }

{
import java.io.*;
import satc.antlr.DocParser;
}


class PlainTextLexer extends Lexer;
options {
    k = 2;                           
    testLiterals = false;
    //importVocab = PlainTextParser;
    exportVocab = PlainText;     
    charVocabulary = '\0'..'\377'; 
    filter = true;
}

{
    public PlainTextLexer() {
        this((LexerSharedInputState) null); 
    }
}

LINE      :     
    ( ~('\n'|'\r') )*
    (
            options {
                generateAmbigWarnings=false;
            }
        :   '\r' '\n'
        |   '\r'
        |   '\n'
    )
    { newline(); }
    ;

{
import java.io.*;
import satc.antlr.DocParser;
}

class PlainTextParser extends Parser;//(DocParser);
options {
    buildAST = true;
    exportVocab = PlainText;
}

tokens { START="START"; }

start!
    : (LINE)*    { ## = #[START,"START"] ; }
    ;


