/* ====================================================================
 *
 * XML Comment Lexer
 *
 * ====================================================================
 */

header {
package satc.lang; 
}

class XMLCommentLexer extends Lexer;

options {
    k = 3;                           
    testLiterals = false;
    charVocabulary = '\3'..'\377';
    importVocab=XMLTagName;
    exportVocab=XMLComment;
    filter = true;
}

{
public XMLCommentLexer() {
    this((LexerSharedInputState) null); 
}
}

XC_CLOSE	
	:	("-->") => "-->"
	|	'-' {$setType(XC_WORD);}
  	;

// Whitespace
XC_WS   :   (   ' '
        |   '\t'
        |   '\f'
        // handle newlines
        |   (   "\r\n"  // Evil DOS
            |   '\r'    // Macintosh
            |   '\n'    // Unix (the right way)
            )
            { newline(); }
        )
//      { _ttype = Token.SKIP; }
    ;

XC_WORD //   options{ testLiterals = true;}
    : (~(' '|'\t'|'\r'|'\n'|'\f'|'-'))+/// | {!(LA(2)=='-' && LA(3)=='>')}? '-')+
    ;

