/* ====================================================================
 *
 * XML Lexer 
 *
 * ====================================================================
 */

header {
package satc.lang; 
}

class XMLLexer extends Lexer;

options {
    k = 3;                           
    testLiterals = false;
    charVocabulary = '\3'..'\377';
    importVocab=XMLComment;
    exportVocab=XML;
    filter = false;
}

{
public XMLLexer() {
    this((LexerSharedInputState) null); 
}
}

/*
TAB    		: 	'\t'	;

BLANK   	: 	' '   	; 

NEWLINE 	: 	('\r' | '\n' | "\r\n") { newline();}   ;
*/

WS  :   (   /*  '\r' '\n' can be matched in one alternative or by matching
                '\r' in one iteration and '\n' in another.  I am trying to
                handle any flavor of newline that comes in, but the language
                that allows both "\r\n" and "\r" and "\n" to all be valid
                newline is ambiguous.  Consequently, the resulting grammar
                must be ambiguous.  I'm shutting this warning off.
             */
            options {
                generateAmbigWarnings=false;
            }
        :   ' '
        |   '\t'
        |   '\r' '\n'   {newline();}
        |   '\r'        {newline();}
        |   '\n'        {newline();}
        )
//        { $setType(Token.SKIP); }
    ;

TAG_START	:	'<' ('/')?	;

TAG_END		:	('/')? '>' 	;

ID    		:   ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'$'|'0'..'9')*  	;

ASSIGN 	 	: "="   ;

STRING_LITERAL
    :   '"' (~'"')* '"'
    ;


XC_OPEN
	:	"<!--"
	;


/*COMMENT
	:	"<!--" c:COMMENT_DATA "-->"
		//{ $setType(Token.SKIP); }
	;

//COMMENT    
// multiple-line comments
protected
COMMENT_DATA
	:	(	/*	'\r' '\n' can be matched in one alternative or by matching
				'\r' in one iteration and '\n' in another.  I am trying to
				handle any flavor of newline that comes in, but the language
				that allows both "\r\n" and "\r" and "\n" to all be valid
				newline is ambiguous.  Consequently, the resulting grammar
				must be ambiguous.  I'm shutting this warning off.
			 */
/*			options {
				generateAmbigWarnings=false;
			}
		:
			{!(LA(2)=='-' && LA(3)=='>')}? '-' // allow '-' if not "-->"
		|	'\r' '\n'		{newline();}
		|	'\r'			{newline();}
		|	'\n'			{newline();}
		|	~('-'|'\n'|'\r')
		)*
	;
*/

