/* ====================================================================
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is SATC.
 *
 * The Initial Developer of the Original Code is Bogdan Mitu
 *
 * Copyright (C) 2001-2002 Bogdan Mitu
 *
 * ====================================================================
 */

header{ package satc.lang; }

class ANTLROptionLexer extends Lexer;

options {
    k=2;
    importVocab = MLC;
    exportVocab = ANTLROptionLexer;
    filter=false;       
    charVocabulary = '\3'..'\377';
    testLiterals = false;
}

tokens {
    "charVocabulary";
    "importVocab"   ;
    "exportVocab"   ;
    "testLiterals"  ;
    "warnWhenFollowAmbig" ; 
    "filter"        ;
    "true"          ;
    "false"         ;
	"k"				;
}

{
    public ANTLROptionLexer() {
       this((LexerSharedInputState) null); 
    }
}
OPTION_EQUAL
	:	'='
     ;

OPTION_CLOSE
    :   "}" 
    ;
 
OPTION_WORD    options{ testLiterals = true; }
    : (~(' '|'\t'|'\r'|'\n'|'\f'|'='|'/'|';'|'*'|'}'))+		//{System.out.println(" -- OPTION_WORD !!! -- ");}
    ;

// Whitespace
OPTION_WS  
	:   (   ' '
        |   '\t'
        |   '\f'
        // handle newlines
        |   (   "\r\n"  // Evil DOS
            |   '\r'    // Macintosh
            |   '\n'    // Unix (the right way)
            )
            { newline(); }
        )
//      { _ttype = Token.SKIP; }
    ;
// Single-line comments
SL_COMMENT
    :   "//" (~('\n'|'\r'))* ('\n'|'\r'('\n')?)   { newline(); }
		| '/'  { $setType( OPTION_WORD); }
    ;

SEMI:   ';'    ;
