/* ====================================================================
 *
 * XML Comment Lexer
 *
 * ====================================================================
 */

header {
package satc.lang; 
}

class XMLTagNameLexer extends Lexer;

options {
    k = 3;                           
    testLiterals = false;
    charVocabulary = '\3'..'\377';
    exportVocab=XMLTagName;
    filter = true;
}

{
public XMLTagNameLexer() {
    this((LexerSharedInputState) null); 
}
}

// Whitespace
XF_WS   :   (   ' '
        |   '\t'
        |   '\f'
        // handle newlines
        |   (   "\r\n"  // Evil DOS
            |   '\r'    // Macintosh
            |   '\n'    // Unix (the right way)
            )
            { newline(); }
        )
//      { _ttype = Token.SKIP; }
    ;

XF_ID //   options{ testLiterals = true;}
    : 	('a'..'z' | 'A'..'Z') ('a'..'z' | 'A'..'Z' | '0'..'9')*
    ;

